<template>
  <v-dialog
    width="50%"
    height="auto"
    v-model="selectedValue"
    name="create_client"
  >
    <v-card>
      <v-card-title class="light">Krijo një grup klientësh</v-card-title>
      <v-container>
        <v-row class="mx-2">
          <v-col class="justify-space-between" cols="6">
            <v-text-field label="Emri*" v-model="request.name" />
          </v-col>
          <v-col cols="6">
            <price-list-select v-model="request.price_list_type_id" />
          </v-col>
        </v-row>
      </v-container>
      <v-card-actions>
        <v-spacer />
        <v-btn text @click="close">Anullo</v-btn>
        <f-submit-btn :loading="loading" :disabled="loading" @click="submit" />
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>
<script lang="ts">
import Vue from 'vue'
import { Component, Prop } from 'vue-property-decorator'
import api from '../../../../plugins/api'
import eventBus from '../../../../plugins/event-bus'
import FSubmitBtn from '../../../../components/buttons/FSubmitBtn.vue'
import PriceListSelect from '../../../../components/selects/PriceListSelect.vue'
@Component({
  components: { PriceListSelect, FSubmitBtn },
})
export default class CreateClientGroup extends Vue {
  @Prop({ type: Boolean, required: true }) value

  request = {
    parent_id: 0,
    name: '',
    price_list_type_id: null,
    margin: 0,
  }
  loading = false

  get selectedValue() {
    return this.value
  }
  set selectedValue(newValue) {
    this.$emit('input', newValue)
  }

  close() {
    this.selectedValue = false
    this.request.name = ''
    this.request.price_list_type_id = null
  }
  submit() {
    if (!this.request.name) return alert('Plotësoni fushat')

    this.loading = true
    api()
      .post('api/crm/client-groups', this.request)
      .then(response => {
        alert(response.data.message)
        this.request.name = ''
        this.request.price_list_type_id = null
        this.selectedValue = false

        eventBus.$emit('refresh')
      })
      .catch(error => {
        alert(error.message)
      })
      .finally(() => {
        this.loading = false
      })
  }
}
</script>
